#include "SoftKeyWindow.hpp"

SoftKeyWindow::SoftKeyWindow(WindowManager* wm_, int width_)
    : Window(wm_) , width(width_), textLeft(NULL), textCenter(NULL), textRight(NULL) {

}

void SoftKeyWindow::paint() {
    AEEDeviceInfo devinfo;
    ISHELL_GetDeviceInfo(wm->shell, &devinfo);
    // IShellC^[tFCX֐gpāAʃTCY擾B
    const int height = 25;
    const int x = devinfo.cyScreen - height;

    FillRect(wm->display,0 , x, width, height, MAKE_RGB(255, 255, 255));

    DrawText(wm->display, textLeft, 0, x);
    DrawText(wm->display, textCenter, width/3, x);
    DrawText(wm->display, textRight, width*2/3, x);
    IDISPLAY_Update(wm->display);
}

void SoftKeyWindow::setText(const BPPString& textLeft_, const BPPString& textCenter_, const BPPString& textRight_) {
    textLeft = textLeft_;
    textCenter = textCenter_;
    textRight = textRight_;
    paint();
}
