package com.s_cradle.lifeapp;

import com.nttdocomo.ui.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: Sophia Cradle, Inc.</p>
 * @author YOSHIMURA Masaru
 * @version $Id$
 */

public class LifeGameApplication extends IApplication {
  public static final int STATE_TITLE = 0;
  public static final int STATE_GAMESTART = 1;
  public static final int STATE_EDIT = 2;
  public static final int STATE_SAVE = 3;
  public static final int STATE_LOAD = 4;
  public static final int STATE_CHANGESIZE = 5;

  private LifeGame lifeGame;
  private LifeGameThread thread;

  public LifeGameApplication() {
    lifeGame = new LifeGame();
  }

  public void start() {
    Display.setCurrent(new LifeGameMainPanel(this));
  }

  /**
   * ԁiʁjJڂ͕K̃\bhʂčsD
   *
   * @param state int STATE_????
   */
  public void changeState(int state){
    switch(state){
      case STATE_GAMESTART:
        LifeGameMainCanvas canvas = new LifeGameMainCanvas(this,lifeGame);
        Display.setCurrent(canvas);
        thread = new LifeGameThread(canvas);
        thread.start();
        break;
      case STATE_TITLE:
        if(thread != null){
          thread.interrupt();
          thread = null;
        }
        Display.setCurrent(new LifeGameMainPanel(this));
        break;
      case STATE_EDIT:
        LifeGameEditCanvas edit = new LifeGameEditCanvas(this,lifeGame);
        Display.setCurrent(edit);
        edit.setCurrent();
        break;
      case STATE_SAVE:
        Display.setCurrent(new SavePanel(this,lifeGame));
        break;
      case STATE_LOAD:
        Display.setCurrent(new LoadPanel(this,lifeGame));
        break;
      case STATE_CHANGESIZE:
        Display.setCurrent(new ChangeSizePanel(this,lifeGame));
        break;
    }
  }
}
