package com.s_cradle.lifeapp;

import com.nttdocomo.ui.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: Sophia Cradle, Inc.</p>
 *
 * @author YOSHIMURA Masaru
 * @version $Id$
 */
public class LifeGameEditCanvas extends LifeGameCanvas {
  private int cursorX = 1;
  private int cursorY = 1;
  private boolean[][] matrix;

  public LifeGameEditCanvas(LifeGameApplication appli, LifeGame game) {
    super(appli, game);

    matrix = game.getMatrix();
    setSoftLabel(Frame.SOFT_KEY_1,"XV");
    setSoftLabel(Frame.SOFT_KEY_2,"I");
  }

  public void setCurrent(){
    matrix = game.getMatrix();
  }

  public void paint(Graphics g) {
    g.lock();

    g.setColor(g.getColorOfName(g.WHITE));
    g.fillRect(0,0,getWidth(),getHeight());
    game.paint(g);
    g.setColor(g.getColorOfName(g.GREEN));
    g.drawRect(cursorY * LifeGame.CELL_WIDTH,cursorX * LifeGame.CELL_HEIGHT,
               LifeGame.CELL_WIDTH-1, LifeGame.CELL_HEIGHT-1);

    g.unlock(true);
  }

  public void processEvent(int type, int param){
    if(type == Display.KEY_RELEASED_EVENT){
      switch(param){
        case Display.KEY_UP:
          if(cursorX > 1){
            cursorX--;
          } else{
            cursorX = matrix[0].length-2;
          }
          repaint();
          break;
        case Display.KEY_DOWN:
          if(cursorX < matrix[0].length-2){
            cursorX++;
          } else{
            cursorX = 1;
          }
          repaint();
          break;
        case Display.KEY_LEFT:
          if(cursorY > 1){
            cursorY--;
          } else{
            cursorY = matrix.length-2;
          }
          repaint();
          break;
        case Display.KEY_RIGHT:
          if(cursorY < matrix.length-2){
            cursorY++;
          } else{
            cursorY = 1;
          }
          repaint();
          break;
        case Display.KEY_SELECT:
          matrix[cursorY][cursorX] = !matrix[cursorY][cursorX];
          repaint();
          break;
        case Display.KEY_SOFT1:
          appli.changeState(LifeGameApplication.STATE_TITLE);
          break;
        case Display.KEY_SOFT2:
          appli.terminate();
          break;
      }
    }
  }
}
